package es.vass.cross.browser.test;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.FileReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.Iterator;
import java.util.Map.Entry;
import java.util.concurrent.TimeUnit;
import org.apache.commons.codec.binary.Base64;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;

public class CrossBrowserTest {

	

	public static void main(String[] args) {

		long milisIni=System.currentTimeMillis();
		System.out.println("Iniciant joc de proves");
		
		try{		
			String urlsAprovar=CrossBrowserTestProperties.getInstancia().getPropietat("LLISTA_URLS_PROVAR");
			long delayProvaMilis =Long.valueOf(CrossBrowserTestProperties.getInstancia().getPropietat("DELAY_PROVA_SEGONS"))*1000;
			
			String[] listaUrlsAProvar = urlsAprovar.split(",");
			
			
			
			for(int i=0;i<listaUrlsAProvar.length;i++){				
				runTest(listaUrlsAProvar[i]);
				Thread.sleep(delayProvaMilis);
			}
					
			
			
			System.out.println("Joc de proves finalitzat en "+formatejaMilis(System.currentTimeMillis()-milisIni));	
		}catch(Exception e){
			System.out.println("S'ha produit un error executant joc de proves");
			e.printStackTrace();			
		}
	}
	
	
	private static void runTest(String urlTest){
		try {
			long milisIni=System.currentTimeMillis();
			System.out.println("");System.out.println("");System.out.println("");
			System.out.println("--------------------------------------------------------");
			System.out.println("Iniciant la prova per a: "+urlTest);
			
			String endPoint=CrossBrowserTestProperties.getInstancia().getPropietat("END_POINT");
			String browserListName=CrossBrowserTestProperties.getInstancia().getPropietat("MATRIU_DISPOSITUS_NAVEGADORS");
			String format=CrossBrowserTestProperties.getInstancia().getPropietat("FORMAT");
			String delay=CrossBrowserTestProperties.getInstancia().getPropietat("DELAY_SCREENSHOT_SEGONS");
			String checkUrl=CrossBrowserTestProperties.getInstancia().getPropietat("CHECK_URL");              
			String userName=CrossBrowserTestProperties.getInstancia().getPropietat("USUARI_CROSS_BROWSER_TEST");
			String password=CrossBrowserTestProperties.getInstancia().getPropietat("PASSWORD_CROSS_BROWSER_TEST");
			
												
			URL url = new URL (endPoint);
			String urlParameters="browser_list_name="+browserListName+"&url="+urlTest+"&format="+format   +"&delay="+delay +"&check_url="+checkUrl;
			String auth = userName+":"+password;
			byte[] authEncBytes = Base64.encodeBase64(auth.getBytes());
			String authStringEnc = new String(authEncBytes);
			
			
						
			HttpURLConnection con = (HttpURLConnection) url.openConnection();
			con.setDoOutput(true);
			con.setRequestMethod("POST");
			con.setRequestProperty("Authorization", "Basic " + authStringEnc);
			
			
			DataOutputStream wr = new DataOutputStream(con.getOutputStream());
		    wr.writeBytes(urlParameters);
		    wr.flush();
		    wr.close();

		    int responseCode = con.getResponseCode();
		   
		    
		    if(responseCode==200){
			    BufferedReader in = new BufferedReader(
			            new InputStreamReader(con.getInputStream()));
			    String inputLine;
			    StringBuffer response = new StringBuffer();
	
			    while ((inputLine = in.readLine()) != null) {
			        response.append(inputLine);
			    }
			    in.close();
	
			    String result=response.toString();
			    
				
				printResult(result);
				
				System.out.println("Porva "+urlTest +" iniciada en "+formatejaMilis(System.currentTimeMillis()-milisIni)+" segons");	
				System.out.println("********************************************************");
		    }else{
		    	System.out.println("S'ha produit un error iniciat el test a la url "+urlTest);
		    	System.out.println("********************************************************");
		    	BufferedReader in = new BufferedReader(
			            new InputStreamReader(con.getInputStream()));
			    String inputLine;
			    StringBuffer response = new StringBuffer();
	
			    while ((inputLine = in.readLine()) != null) {
			        response.append(inputLine);
			    }
			    in.close();
	
			    String result=response.toString();
			    
			    System.out.println(result);
		    }
		      
		      
			
		}catch (Exception e) {
			e.printStackTrace();
		}
	}

	
	private static void printResult(String result) {
		JSONParser parser = new JSONParser();

		try {
			Object obj = parser.parse(result);
			
			JSONObject jsonObject = (JSONObject) obj;
			System.out.println(jsonObject.toString().substring(jsonObject.toString().indexOf("screenshot_test_id"),jsonObject.toString().indexOf("screenshot_test_id")+27));
			//JSONArray jsonArray = (JSONArray) jsonObject.get("versions");
			
			//Iterator<JSONObject> it = jsonArray.iterator();
			
			/*while(it.hasNext()){
				JSONObject jsonObjectVersion = it.next();
				Iterator<Entry> it2=jsonObjectVersion.entrySet().iterator();							
				
				while(it2.hasNext()){
					Entry entry = it2.next();
					if(entry.getKey().equals("show_results_web_url"))
						System.out.println("Consultar estat i resultats: "+entry.getValue());
					else if(entry.getKey().equals("screenshot_test_id"))
						System.out.println("ID version: "+entry.getValue());	
					else if(entry.getKey().equals("show_comparisons_web_url"))
						System.out.println("Comparador vistes: "+entry.getValue());
					else if(entry.getKey().equals("download_results_zip_url"))
						System.out.println("Descarregar captures: "+entry.getValue());	
					
				}
			}*/
						
		}catch (Exception e) {
			e.printStackTrace();
		}			
	}

	private static String formatejaMilis(long milis){			
		return String.format("%d min, %d sec", 
			    TimeUnit.MILLISECONDS.toMinutes(milis),
			    TimeUnit.MILLISECONDS.toSeconds(milis) - 
			    TimeUnit.MINUTES.toSeconds(TimeUnit.MILLISECONDS.toMinutes(milis)));
	}
	
	private static String readFile( String file ) throws Exception {
	    BufferedReader reader = new BufferedReader( new FileReader (file));
	    String         line = null;
	    StringBuilder  stringBuilder = new StringBuilder();
	    String         ls = System.getProperty("line.separator");

	    while( ( line = reader.readLine() ) != null ) {
	        stringBuilder.append( line );
	        stringBuilder.append( ls );
	    }

	    return stringBuilder.toString();
	}
	
}
